#ifndef DEFERREDPIPELINE_H
#define DEFERREDPIPELINE_H

#include "pipeline.h"
#include "framebuffer.h"
#include <unordered_map>
#include <glm/mat4x4.hpp>

class Shader;
class Camera;

class GuiBuffer : public FrameBuffer
{
   unsigned int m_rbo;
public:
    GuiBuffer(int width, int height);
    ~GuiBuffer();
};

class GuiPipeline : public Pipeline
{
    Camera *m_camera;
    
    int m_width;
    int m_height;
    
    glm::mat4 m_orthoMatrix;

    // shaders
    std::vector<unsigned int> m_meshTypes;
    
    std::unordered_map<unsigned int, Shader*> m_meshShaders;
    
    ShaderSource *m_guiShader;
    
    // framebuffers
    GuiBuffer *m_guiBuffer;
    const FrameBuffer *m_renderTarget;

public:
    GuiPipeline();

    void refreshScene(Scene *scene);
    
    virtual void renderGL(Scene *scene);
    virtual void resizeGL(int w, int h);

    void setSources(ShaderSource *guiSource);
};

#endif // DEFERREDPIPELINE_H
