#ifndef IMAGE
#define IMAGE

#include <string>
#include <vector>

struct Image
{
    int width;
    int height;
    int depth;
    std::string m_name;
    std::vector<unsigned char> pixels;

    Image() : width(0), height(0), depth(8) {}

    Image(const std::string &name, int myDepth, int myWidth, int myHeight, float frequency, float amplitude);

    void allocate(int size)
        { pixels.resize(size); }
    
    /*
     * PNG serialization
     */
    Image(const std::string &pngFile);

    Image(const unsigned char *pngPtr, size_t size);

    bool save(const std::string &filename);

    bool save(std::vector<unsigned char> &out);
};

struct TexturePack
{
    std::string m_name;
    std::vector<Image> m_images;

    TexturePack(std::string name) : m_name(name) {}
    TexturePack(const std::string &filename);
    bool save(const std::string &filename);
};

#endif // IMAGE

